import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class ControllerServ extends HttpServlet {

  private ServletContext context;
  private Command command;            // obiekt klasy wykonawczej
  private String presentationServ;    // nazwa serwlet prezentacji
  private String getParamsServ;       // mazwa serwletu pobierania parametrw
  private Object lock = new Object(); // semafor dla synchronizacji
                                      // odwoa wielu wtkw
  public void init() {

    context = getServletContext();

    presentationServ = context.getInitParameter("presentationServ");
    getParamsServ = context.getInitParameter("getParamsServ");
    String commandClassName = context.getInitParameter("commandClassName");

    // Zaadowanie klasy Command i utworzenie jej egzemplarza
    // ktry bdzie wykonywa prac
    try {
      Class commandClass = Class.forName(commandClassName);
      command = (Command) commandClass.newInstance();
    } catch (Exception exc) {
        throw new NoCommandException("Couldn't find or instantiate " +
                                      commandClassName);
    }
  }

  // Obsuga zlece
  public void serviceRequest(HttpServletRequest req,
                             HttpServletResponse resp)
                             throws ServletException, IOException
  {

    resp.setContentType("text/html");

    // Wywolanie serwletu pobierania parametrw
    RequestDispatcher disp = context.getRequestDispatcher(getParamsServ);
    disp.include(req,resp);

    // Pobranie biecej sesji
    // i z jej atrybutw - wartoci parametrw
    // ustalonych przez servlet pobierania parametrw
    // Rne informacje o apliakcji (np. nazwy parametrw)
    // s wygodnie dostpne poprzez wasn klas BundleInfo

    HttpSession ses = req.getSession();

    String[] pnames = BundleInfo.getCommandParamNames();
    for (int i=0; i<pnames.length; i++) {

      String pval = (String) ses.getAttribute("param_"+pnames[i]);

      if (pval == null) return;  // jeszcze nie ma parametrw

      // Ustalenie tych parametrw dla Command
      command.setParameter(pnames[i], pval);
    }

    // Wykonanie dziaa definiowanych przez Command
    // i pobranie wynikw
    // Poniewa do serwletu moe naraz odwoywa sie wielu klientw
    // (wiele watkw) - potrzebna jest synchronizacja

    synchronized(lock) {
      // wykonanie
      command.execute();

      // pobranie wynikw
      List results = (List) command.getResults();

      // Pobranie i zapamitanie kodu wyniku (dla servletu prezentacji)
      ses.setAttribute("StatusCode", new Integer(command.getStatusCode()));

      // Wyniki - bd dostpne jako atrybut sesji
      ses.setAttribute("Results", results);
    }

    // Wywoanie serwletu prezentacji
    disp = context.getRequestDispatcher(presentationServ);
    disp.forward(req, resp);
  }


  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
                 throws ServletException, IOException
  {
      serviceRequest(request, response);
  }

  public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
                 throws ServletException, IOException
  {
      serviceRequest(request, response);
  }

}